import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * Beschreibung
 *
 * @version 1.0 vom 28.09.2019
 * @author 
 */

public class PuzzleGui extends JFrame {
  // Anfang Attribute
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JButton jButton3 = new JButton();
  private JButton jButton4 = new JButton();
  private JButton jButton5 = new JButton();
  private JButton jButton6 = new JButton();
  private JButton jButton7 = new JButton();
  private JButton jButton8 = new JButton();
  private JButton jButton9 = new JButton();
  private JButton jButton10 = new JButton();
  private JButton jButton11 = new JButton();
  
  private Puzzle puzzle;
  
  // Ende Attribute
  
  public PuzzleGui() { 
    // Frame-Initialisierung
    super();
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 300;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setTitle("PuzzleGui");
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    jButton1.setBounds(16, 8, 59, 57);
    jButton1.setText("1");
    jButton1.setMargin(new Insets(2, 2, 2, 2));
    jButton1.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jButton2.setBounds(112, 8, 59, 57);
    jButton2.setText("2");
    jButton2.setMargin(new Insets(2, 2, 2, 2));
    jButton2.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton2_ActionPerformed(evt);
      }
    });
    cp.add(jButton2);
    jButton3.setBounds(208, 8, 59, 57);
    jButton3.setText("3");
    jButton3.setMargin(new Insets(2, 2, 2, 2));
    jButton3.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton3_ActionPerformed(evt);
      }
    });
    cp.add(jButton3);
    jButton4.setBounds(16, 72, 59, 57);
    jButton4.setText("4");
    jButton4.setMargin(new Insets(2, 2, 2, 2));
    jButton4.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton4_ActionPerformed(evt);
      }
    });
    cp.add(jButton4);
    jButton5.setBounds(112, 72, 59, 57);
    jButton5.setText("5");
    jButton5.setMargin(new Insets(2, 2, 2, 2));
    jButton5.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton5_ActionPerformed(evt);
      }
    });
    cp.add(jButton5);
    jButton6.setBounds(208, 72, 59, 57);
    jButton6.setText("6");
    jButton6.setMargin(new Insets(2, 2, 2, 2));
    jButton6.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton6_ActionPerformed(evt);
      }
    });
    cp.add(jButton6);
    jButton7.setBounds(16, 144, 59, 57);
    jButton7.setText("7");
    jButton7.setMargin(new Insets(2, 2, 2, 2));
    jButton7.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton7_ActionPerformed(evt);
      }
    });
    cp.add(jButton7);
    jButton8.setBounds(112, 144, 59, 57);
    jButton8.setText("8");
    jButton8.setMargin(new Insets(2, 2, 2, 2));
    jButton8.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton8_ActionPerformed(evt);
      }
    });
    cp.add(jButton8);
    jButton9.setBounds(208, 144, 59, 57);
    jButton9.setText("9");
    jButton9.setMargin(new Insets(2, 2, 2, 2));
    jButton9.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton9_ActionPerformed(evt);
      }
    });
    cp.add(jButton9);
    jButton10.setBounds(32, 220, 91, 32);
    jButton10.setText("neu");
    jButton10.setMargin(new Insets(2, 2, 2, 2));
    jButton10.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton10_ActionPerformed(evt);
      }
    });
    cp.add(jButton10);
    jButton11.setBounds(152, 220, 91, 32);
    jButton11.setText("beenden");
    jButton11.setMargin(new Insets(2, 2, 2, 2));
    jButton11.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton11_ActionPerformed(evt);
      }
    });
    cp.add(jButton11);
    // Ende Komponenten
    
    setVisible(true);
    
    // Puzzleattribute
    puzzle = new Puzzle();
    aktualisiereDarstellung();
  } // end of public PuzzleGui
  
  // Anfang Methoden
  
  public static void main(String[] args) {
    new PuzzleGui();
  } // end of main
  
  /**
   * die Action-Methoden pruefen selbst die Zulaessigkeit
   */
  public void jButton1_ActionPerformed(ActionEvent evt) {
      if (jButton2.getText()==" ") {
          int[] von={0,0};
          int[] auf={0,1};
          puzzle.setze(von,auf);
          jButton2.setText(jButton1.getText());
          jButton1.setText(" ");
      }
      else if (jButton4.getText()==" ") {
          int[] von={0,0};
          int[] auf={1,0};
          puzzle.setze(von,auf);
          jButton4.setText(jButton1.getText());
          jButton1.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton1_ActionPerformed

  public void jButton2_ActionPerformed(ActionEvent evt) {
      if (jButton1.getText()==" ") {
          int[] von={0,1};
          int[] auf={0,0};
          puzzle.setze(von,auf);
          jButton1.setText(jButton2.getText());
          jButton2.setText(" ");
      }
      else if (jButton3.getText()==" ") {
          int[] von={0,1};
          int[] auf={0,2};
          puzzle.setze(von,auf);
          jButton3.setText(jButton2.getText());
          jButton2.setText(" ");
      }
      else if (jButton5.getText()==" ") {
          int[] von={0,1};
          int[] auf={1,1};
          puzzle.setze(von,auf);
          jButton5.setText(jButton2.getText());
          jButton2.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton2_ActionPerformed

  public void jButton3_ActionPerformed(ActionEvent evt) {
      if (jButton2.getText()==" ") {
          int[] von={0,2};
          int[] auf={0,1};
          puzzle.setze(von,auf);
          jButton2.setText(jButton3.getText());
          jButton3.setText(" ");
      }
      else if (jButton6.getText()==" ") {
          int[] von={0,2};
          int[] auf={1,2};
          puzzle.setze(von,auf);
          jButton6.setText(jButton3.getText());
          jButton3.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton3_ActionPerformed

  public void jButton4_ActionPerformed(ActionEvent evt) {
      if (jButton1.getText()==" ") {
          int[] von={1,0};
          int[] auf={0,0};
          puzzle.setze(von,auf);
          jButton1.setText(jButton4.getText());
          jButton4.setText(" ");
      }
      else if (jButton5.getText()==" ") {
          int[] von={1,0};
          int[] auf={1,1};
          puzzle.setze(von,auf);
          jButton5.setText(jButton4.getText());
          jButton4.setText(" ");
      }
      else if (jButton7.getText()==" ") {
          int[] von={1,0};
          int[] auf={2,0};
          puzzle.setze(von,auf);
          jButton7.setText(jButton4.getText());
          jButton4.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton4_ActionPerformed

  public void jButton5_ActionPerformed(ActionEvent evt) {
      if (jButton2.getText()==" ") {
          int[] von={1,1};
          int[] auf={0,1};
          puzzle.setze(von,auf);
          jButton2.setText(jButton5.getText());
          jButton5.setText(" ");
      }
      else if (jButton4.getText()==" ") {
          int[] von={1,1};
          int[] auf={1,0};
          puzzle.setze(von,auf);
          jButton4.setText(jButton5.getText());
          jButton5.setText(" ");
      }
      else if (jButton6.getText()==" ") {
          int[] von={1,1};
          int[] auf={1,2};
          puzzle.setze(von,auf);
          jButton6.setText(jButton5.getText());
          jButton5.setText(" ");
      }
      else if (jButton8.getText()==" ") {
          int[] von={1,1};
          int[] auf={2,1};
          puzzle.setze(von,auf);
          jButton8.setText(jButton5.getText());
          jButton5.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton5_ActionPerformed

  public void jButton6_ActionPerformed(ActionEvent evt) {
      if (jButton3.getText()==" ") {
          int[] von={1,2};
          int[] auf={0,2};
          puzzle.setze(von,auf);
          jButton3.setText(jButton6.getText());
          jButton6.setText(" ");
      }
      else if (jButton5.getText()==" ") {
          int[] von={1,2};
          int[] auf={1,1};
          puzzle.setze(von,auf);
          jButton5.setText(jButton6.getText());
          jButton6.setText(" ");
      }
      else if (jButton9.getText()==" ") {
          int[] von={1,2};
          int[] auf={2,2};
          puzzle.setze(von,auf);
          jButton9.setText(jButton6.getText());
          jButton6.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton6_ActionPerformed

  public void jButton7_ActionPerformed(ActionEvent evt) {
      if (jButton4.getText()==" ") {
          int[] von={2,0};
          int[] auf={1,0};
          puzzle.setze(von,auf);
          jButton4.setText(jButton7.getText());
          jButton7.setText(" ");
      }
      else if (jButton8.getText()==" ") {
          int[] von={2,0};
          int[] auf={2,1};
          puzzle.setze(von,auf);
          jButton8.setText(jButton7.getText());
          jButton7.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton7_ActionPerformed

  public void jButton8_ActionPerformed(ActionEvent evt) {
      if (jButton5.getText()==" ") {
          int[] von={2,1};
          int[] auf={1,1};
          puzzle.setze(von,auf);
          jButton5.setText(jButton8.getText());
          jButton8.setText(" ");
      }
      else if (jButton7.getText()==" ") {
          int[] von={2,1};
          int[] auf={2,0};
          puzzle.setze(von,auf);
          jButton7.setText(jButton8.getText());
          jButton8.setText(" ");
      }
      else if (jButton9.getText()==" ") {
          int[] von={2,1};
          int[] auf={2,2};
          puzzle.setze(von,auf);
          jButton9.setText(jButton8.getText());
          jButton8.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton8_ActionPerformed

  public void jButton9_ActionPerformed(ActionEvent evt) {
      if (jButton6.getText()==" ") {
          int[] von={2,2};
          int[] auf={1,2};
          puzzle.setze(von,auf);
          jButton6.setText(jButton9.getText());
          jButton9.setText(" ");
      }
      else if (jButton8.getText()==" ") {
          int[] von={2,2};
          int[] auf={2,1};
          puzzle.setze(von,auf);
          jButton8.setText(jButton9.getText());
          jButton9.setText(" ");
      }
      if (puzzle.istFertig()) fertig();
  } // end of jButton9_ActionPerformed

  public void jButton10_ActionPerformed(ActionEvent evt) {
      puzzle.mische();
      aktualisiereDarstellung();
  } // end of jButton10_ActionPerformed

  public void jButton11_ActionPerformed(ActionEvent evt) {
    System.exit(0);    
  } // end of jButton11_ActionPerformed
  
  /**
   * passt die Darstellung an das Feld an
   */
  public void aktualisiereDarstellung() {
      int[][] feld=puzzle.gibFeld();
      jButton1.setText(zuStr(feld[0][0]));
      jButton2.setText(zuStr(feld[0][1]));
      jButton3.setText(zuStr(feld[0][2]));
      jButton4.setText(zuStr(feld[1][0]));
      jButton5.setText(zuStr(feld[1][1]));
      jButton6.setText(zuStr(feld[1][2]));
      jButton7.setText(zuStr(feld[2][0]));
      jButton8.setText(zuStr(feld[2][1]));
      jButton9.setText(zuStr(feld[2][2]));
  }
  
  /**
   * 
   * Hilfsfunktion fuer aktualisiereDarstellung
   */
  private String zuStr(int zahl) {
      if (zahl==0) return " ";
      else return (""+zahl);
  }

  private void fertig() {
      JOptionPane.showMessageDialog(this, "Ziel erreicht !","Fertig !", JOptionPane.INFORMATION_MESSAGE);
  }
  // Ende Methoden
} // end of class PuzzleGui

